﻿Public Class MainForm

    'нажатия кнопок F1 F2
    Private Sub TabControl1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TabControl1.KeyDown
        Dim myAL As New ArrayList()
        If e.KeyCode = Keys.F1 Then AboutBox.ShowDialog()
        If e.KeyCode = Keys.F2 Then
            If fKey = 1 Then
                fKey = 0
            Else
                fKey = 1
            End If
            ShowHideTab()
        End If
    End Sub

    'Переход по закладкам
    Private Sub TabControl1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl1.SelectedIndexChanged
        Select Case TabControl1.SelectedIndex
            Case 0
                InitTabAccount() 'инициализация закладки Account   
                Size = New System.Drawing.Size(363, 192)
            Case 1
                InitTabDatabase() 'инициализация закладки Database
                Size = New System.Drawing.Size(363, 264)
            Case 2
                InitTabKey() 'инициализация закладки Key   
                Size = New System.Drawing.Size(363, 168)

        End Select
    End Sub

    '-----------------------------------------------------------------------------------------------------------
    'Функции закладки Account
    '-----------------------------------------------------------------------------------------------------------
    Private Sub aCbDatabase_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles aCbDatabase.SelectedValueChanged
        SetIntegratedFromAutoLogon()
    End Sub
    Private Sub aCbDatabase_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles aCbDatabase.TextChanged
        aShowBtExitConnect()
    End Sub
    Private Sub aCbKey_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles aCbKey.TextChanged
        aShowBtExitConnect()
    End Sub
    Private Sub aTbUserID_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles aTbUserID.TextChanged
        aShowBtExitConnect()
    End Sub
    Private Sub aTbPassword_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles aTbPassword.TextChanged
        aShowBtExitConnect()
    End Sub
    Private Sub aChbAutoLogon_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles aChbAutoLogon.CheckedChanged
        If aChbAutoLogon.Checked Then
            aTbUserID.Enabled = False
            aTbPassword.Enabled = False
        Else
            aTbUserID.Enabled = True
            aTbPassword.Enabled = True
        End If
    End Sub

    Sub aShowBtExitConnect() 'скрыть/показать кнопки закладки
        If Trim(aCbDatabase.Text) <> "" And Trim(aCbKey.Text) <> "" And Trim(aTbUserID.Text) <> "" And Trim(aTbPassword.Text) <> "" Then
            aBtConnect.Visible = True
            If fKey = 0 Then
                aBtExit.Visible = True
                aBtOpen.Visible = True
                'Label11.Visible = True
                Label11.Text = "Save and"
            End If
        Else

            aBtConnect.Visible = False
            If fKey = 0 Then
                aBtExit.Visible = False
                aBtOpen.Visible = False
                'Label11.Visible = False
                Label11.Text = "Press F1 to help"
            End If
        End If
    End Sub
    Private Sub aBtExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles aBtExit.Click
        xmlSave()       'сохранить текущую секцию конфигурации
        SetReg()        'обновить записи в реестре
        SetGuardant()   'обновить секцию файла ключа
        DelObject()
        Close()
    End Sub
    Private Sub aBtOpen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles aBtOpen.Click
        xmlSave()       'сохранить текущую секцию конфигурации
        SetReg()        'обновить записи в реестре
        SetGuardant()   'обновить секцию файла ключа
        LotsiaRun(0)     'Запустить LotsiaPDM Plus с параметрами
        DelObject()
        Close()
    End Sub
    Private Sub aBtConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles aBtConnect.Click
        xmlSave()       'сохранить текущую секцию конфигурации
        SetReg()        'обновить записи в реестре
        SetGuardant()   'обновить секцию файла ключа
        LotsiaRun(1)     'Запустить LotsiaPDM Plus с параметрами
        DelObject()
        Close()         'Выйти из программы
    End Sub

    '-----------------------------------------------------------------------------------------------------------
    'Функции закладки Database
    '-----------------------------------------------------------------------------------------------------------
    Private Sub dCbDesc_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles dCbDesc.SelectedValueChanged
        InitTabDatabaseExt() 'прочитать выбранную секцию инициализации
    End Sub
    Private Sub dCbDBMS_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles dCbDBMS.SelectedValueChanged
        Select Case dCbDBMS.Text
            Case "Microsoft SQL Server"
                dLbExt.Visible = False
                dCbOraDrv.Visible = False
                dCbDNS.Visible = False
                dCbDBMSExt.Visible = False

                dLbServerName.Visible = True
                dLbServerName.Text = "Server Name"
                dTbServer.Visible = True
                dLbDatabaseName.Visible = True
                dTbDatabase.Visible = True
            Case "Oracle"
                dLbExt.Visible = True
                dLbExt.Text = "Driver Version"
                dCbOraDrv.Visible = True
                dCbOraDrv.Text = "Oracle 8, 8i"
                dCbDNS.Visible = False
                dCbDBMSExt.Visible = False

                dLbServerName.Visible = True
                dLbServerName.Text = "Connecting String"
                dTbServer.Visible = True
                dLbDatabaseName.Visible = False
                dTbDatabase.Visible = False
            Case "Sybase SQL Anywhere"
                dLbExt.Visible = True
                dLbExt.Text = "Driver Version"
                dCbOraDrv.Visible = False
                dCbDNS.Visible = True
                dCbDNS.Text = "Sybase SQL Anywhere (ODBC)"

        End Select
    End Sub
    Private Sub dCbDNS_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles dCbDNS.SelectedValueChanged
        If dCbDNS.Text = "Sybase SQL Anywhere (ODBC)" Then
            dLbServerName.Text = "Source ODBC"
            dCbDBMSExt.Visible = True
            dTbServer.Visible = False
            dLbDatabaseName.Visible = False
            dTbDatabase.Visible = False
        Else
            dLbServerName.Text = "Server Name"
            dCbDBMSExt.Visible = False
            dTbServer.Visible = True
            dLbDatabaseName.Visible = True
            dTbDatabase.Visible = True
        End If
    End Sub

    Private Sub dCbDesc_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles dCbDesc.TextChanged
        dShowBtSaveDel()
    End Sub

    Sub dShowBtSaveDel() 'скрыть/показать кнопки закладки
        '       If Trim(ComboBox3.Text) <> "" And Trim(TextBox3.Text) <> "" And Trim(TextBox4.Text) <> "" Then
        If Trim(dCbDesc.Text) <> "" Then 'And Trim(dTbServer.Text) <> "" Then
            dBtSave.Visible = True
        Else
            dBtSave.Visible = False
        End If
        If Trim(dCbDesc.Text) <> "" And Not xmlDoc.SelectSingleNode("//Servers/Server[@Desc='" & Trim(dCbDesc.Text) & "']") Is Nothing Then
            dBtDel.Visible = True
        Else
            dBtDel.Visible = False
        End If
    End Sub
    Private Sub dBtSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dBtSave.Click
        AddListDatabase() 'добавить новую секцию конфигурации
    End Sub
    Private Sub dBtDel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dBtDel.Click
        DelListDatabase() 'удалить существующую секцию конфигурации
    End Sub

    '-----------------------------------------------------------------------------------------------------------
    'Функции закладки Key
    '-----------------------------------------------------------------------------------------------------------
    Private Sub kCbDesc_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles kCbDesc.SelectedValueChanged
        InitTabKeyExt() 'прочитать выбранную секцию инициализации
    End Sub
    Private Sub kCbDesc_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles kCbDesc.TextChanged
        kShowBtSaveDel()
    End Sub

    Sub kShowBtSaveDel() 'скрыть/показать кнопки закладки
        If Trim(kCbDesc.Text) <> "" Then ' And Trim(kTbIp_name.Text) <> "" Then
            kBtSave.Visible = True
        Else
            kBtSave.Visible = False
        End If
        If Trim(kCbDesc.Text) <> "" And Not xmlDoc.SelectSingleNode("//Keys/Key[@Desc='" & Trim(kCbDesc.Text) & "']") Is Nothing Then
            kBtDel.Visible = True
        Else
            kBtDel.Visible = False
        End If
    End Sub
    Private Sub kBtSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles kBtSave.Click
        AddListKey() 'добавить новую секцию конфигурации
    End Sub
    Private Sub kBtDel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles kBtDel.Click
        DelListKey() 'удалить существующую секцию конфигурации
    End Sub
    '-----------------------------------------------------------------------------------------------------------

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub
End Class

