﻿Public NotInheritable Class AboutBox

    Private Sub AboutBox1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Установить заголовок формы.
        Dim ApplicationTitle As String
        If My.Application.Info.Title <> "" Then
            ApplicationTitle = My.Application.Info.Title
        Else
            ApplicationTitle = System.IO.Path.GetFileNameWithoutExtension(My.Application.Info.AssemblyName)
        End If
        Me.Text = String.Format("О программе {0}", ApplicationTitle)
        ' Инициализировать текст, отображаемый в окне "О программе".
        ' TODO: настроить сведения о сборке приложения в области "Приложение" диалогового окна 
        '    свойств проекта (в меню "Проект").
        Me.LabelProductName.Text = My.Application.Info.ProductName & ". " & _
                                   String.Format("Версия {0}", My.Application.Info.Version.ToString) & ". " & _
                                   My.Application.Info.Copyright
        Me.LabelCompanyName.Text = My.Application.Info.CompanyName
        Me.TextBoxDescription.Text = My.Application.Info.Description & vbCrLf & vbCrLf & _
           "предназначен для работы с ПО LotsiaPDMPlus версии 4.хх и выше хранящей конфигурационные данные в реестре \\ws.ini и использующей ключ аппаратной защиты компании Guardant" & vbCrLf & vbCrLf & _
           "Закладка Account:" & vbCrLf & _
           " (пользовательские настройки, используются ранее сохраненные значения и значения по умолчанию)" & vbCrLf & _
           " - Выбор из списка доступных конфигураций для БД и ключа аппаратной защиты" & vbCrLf & _
           " - Ввод логина и пароля или использование интегрированных значений" & vbCrLf & _
           " - При установке всех значений, по кнопке Connect - запуск Lotsia PDM Plus в режиме cmd (с параметрами) с сохранением текущих настроек:" & vbCrLf & _
           "     * в конфигурационном файле " & My.Resources.xmlFileName & " в секции Default" & vbCrLf & _
           "     * в системном реестре (логин, флаг Integrated)" & vbCrLf & _
           "     * в конфигурационном файле ключа gnclient.ini - ключи IP_Name, Search" & vbCrLf & vbCrLf & _
           " Кнопка F2 включение/выключение режима редактирования конфигураций" & vbCrLf & _
           " (административные настройки, создание/удаление конфигураций для БД и ключа аппаратной защиты)" & vbCrLf & vbCrLf & _
           "Закладка Account:" & vbCrLf & _
           "(дополнительно к базовым параметрам):" & vbCrLf & _
           " - Кнопка Exit (сохранение текущих значений в файле конфигурации, реестре, файле ключа и выход из программы)" & vbCrLf & _
           " - Кнопка Open (сохранение текущих значений в файле конфигурации, реестре, файле ключа и запуск Lotsia PDM Plus в режиме cmd (без параметров))" & vbCrLf & vbCrLf & _
           "Закладка Lotsia Database:" & vbCrLf & _
           " Создание/Удаление конфигураций для БД Лоции в конфигурационном файле " & My.Resources.xmlFileName & vbCrLf & _
           " (полное дублирование окна настроек Lotsia PDM Plus... насколько это возможно ;-) за исключением раздела ODBS -не на чем было отладить)" & vbCrLf & _
           " - Кнопка Save (создание/обновление новой/существующей конфигурации) - введите наименование в поле Description" & vbCrLf & _
           "     * в случае если конфигурация с данным именем присутствует в конфигурационном файле - она будет обновлена" & vbCrLf & _
           "     * в случае если конфигурация с данным именем отсутствует в конфигурационном файле - она будет создана" & vbCrLf & _
           " - Кнопка Del (удаление существующей конфигурации)" & vbCrLf & _
           "     * доступна, если конфигурация с данным именем присутствует в конфигурационном файле" & vbCrLf & vbCrLf & _
           "Закладка Guardant Key:" & vbCrLf & _
           " Создание/Удаление конфигураций для ключа аппаратной защиты Guardant в файле " & My.Resources.xmlFileName & vbCrLf & _
           " - Кнопка Save (создание/обновление новой/существующей конфигурации) - введите наименование в поле Description" & vbCrLf & _
           "     * в случае если конфигурация с данным именем присутствует в конфигурационном файле - она будет обновлена" & vbCrLf & _
           "     * в случае если конфигурация с данным именем отсутствует в конфигурационном файле - она будет создана" & vbCrLf & _
           " - Кнопка Del (удаление существующей конфигурации)" & vbCrLf & _
           "     * доступна, если конфигурация с данным именем присутствует в конфигурационном файле" & vbCrLf & vbCrLf & _
           "ps" & vbCrLf & _
           "в случае отсутствия конфигурационного файла " & My.Resources.xmlFileName & " - он будет создан автоматически, в каталоге расположения программы, при первом сохранении параметров"
    End Sub

    Private Sub OKButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OKButton.Click
        Me.Close()
    End Sub
End Class
